/**
 * @fileoverview No unused React component methods
 * @author Nir
 */
"use strict";

let flag = 0;
//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------

function isReactComponent (node, context) {
  if (!node.superClass) {
    return false;
  }
  return /^(React\.)?(Pure)?Component$/.test(context.getSourceCode().getText(node.superClass));
}

module.exports = {
    meta: {
        docs: {
            description: "No unused React component methods",
            category: "Fill me in",
            recommended: false
        },
        fixable: null,  // or "code" or "whitespace"
        schema: [
            // fill in your schema
        ]
    },

    create: function(context) {
        // variables should be defined here

        //----------------------------------------------------------------------
        // Helpers
        //----------------------------------------------------------------------

        // any helper functions should go here or else delete this section

        //----------------------------------------------------------------------
        // Public
        //----------------------------------------------------------------------

        return {

            'ClassDeclaration': (node) => {
              if(isReactComponent(node, context)){
                // console.log('**********blamos', node.id.name, context.getSourceCode().getText(node.superClass));
                if(flag){
                  // console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr');
                  // console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr', context.getScope(node));
                  flag=false;
                }
              }

            },
            // 'ClassDeclaration[superClass.name="Component"]': (node) => {
            //   console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr');
            // },
            'MethodDefinition': (node) => {
              if(flag<1){
                console.log('nirrrrrrrrrrr!!!!!!!!!!!',context.getScope(node));
                flag++;
              }
            }

        };
    }
};
