/**
 * @fileoverview No unused React component methods
 * @author Nir
 */
"use strict";

let flag = true;
//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------

function isReactComponent (node, context) {
  if (!node.superClass) {
    return false;
  }
  return /^(React\.)?(Pure)?Component$/.test(context.getSourceCode().getText(node.superClass));
}

function getClassNameScope(node, context){
  let i = 10;
  let scope = context.getScope(node);
  while(i > 0){
    if(scope.type === 'class') {
      console.log('*****************blcok',scope.block.id.name);
      return;
    }
    i--;
    scope = scope.upper;
  }
}

module.exports = {
    meta: {
        docs: {
            description: "No unused React component methods",
            category: "Fill me in",
            recommended: false
        },
        fixable: null,  // or "code" or "whitespace"
        schema: [
            // fill in your schema
        ]
    },

    create: function(context) {
        // variables should be defined here

        //----------------------------------------------------------------------
        // Helpers
        //----------------------------------------------------------------------

        // any helper functions should go here or else delete this section

        //----------------------------------------------------------------------
        // Public
        //----------------------------------------------------------------------

        return {

            'ClassDeclaration': (node) => {
              if(isReactComponent(node, context)){
                // console.log('**********blamos', node.id.name, context.getSourceCode().getText(node.superClass));
                if(flag){
                  // console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr');
                  // console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr', context.getScope(node));
                  // flag=false;
                }
              }

            },
            // 'ClassDeclaration[superClass.name="Component"]': (node) => {
            //   console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr');
            // },
            // 'MethodDefinition': (node) => {
            //   if(context.getScope(node).references.length === 0 && flag){
            //       console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr', node.key.name, node);
            //       flag = false;

            //   }
            //   // if(flag<1){
            //   //   console.log('nirrrrrrrrrrr!!!!!!!!!!!',context.getScope(node).references);
            //   //   flag++;
            //   // }
            // },
            'MemberExpression': (node) => {
                if(node.object.type === 'ThisExpression' && node.property.name === '_onLoginButtonPressed'){
                  // console.log('**************',context.getScope(node).upper.upper.type);
                  getClassNameScope(node, context);
                }
            }

        };
    }
};
