/**
 * @fileoverview No unused React component methods
 * @author Nir
 */
"use strict";

//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------

function isReactComponent (node, context) {
  if (!node.superClass) {
    return false;
  }
  return /^(React\.)?(Pure)?Component$/.test(context.getSourceCode().getText(node.superClass));
}

function getClassNameScope(node, context){
  let scope = context.getScope(node);
  while(scope){
    if(scope.type === 'class') {
      console.log('*****************blcok',scope.block.id.name);
      return;
    }
    scope = scope.upper;
  }
}

module.exports = {
    meta: {
        docs: {
            description: "No unused React component methods",
            category: "Fill me in",
            recommended: false
        },
        fixable: null,  // or "code" or "whitespace"
        schema: [
            // fill in your schema
        ]
    },

    create: function(context) {
        // variables should be defined here

        //----------------------------------------------------------------------
        // Helpers
        //----------------------------------------------------------------------

        // any helper functions should go here or else delete this section

        //----------------------------------------------------------------------
        // Public
        //----------------------------------------------------------------------
        let methods = {};
        return {
            'ClassDeclaration': (node) => {
              if(isReactComponent(node, context)){
                
              }

            },
            // 'ClassDeclaration[superClass.name="Component"]': (node) => {
            //   console.log('nirrrrrrrrrrrrrrrrrrrrrrrrr');
            // },
            'MethodDefinition': (node) => {
              methods[node.key.name] = false;
            },
            'MemberExpression': (node) => {
                if(node.object.type === 'ThisExpression'){
                    methods[node.property.name] = true;
                  // console.log('**************',context.getScope(node).upper.upper.upper.upper.upper.upper.upper);
                  // getClassNameScope(node, context);
                }
            },
            'ClassDeclaration:exit': (node) => {
                console.log('class for:', node.id.name, ' ', JSON.stringify(methods) );
                methods = {};
            }
        };
    }
};
